﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using GridTestProject.Annotations;

namespace GridTestProject
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {


        public MainWindow()
        {
            InitTestData();
            DataContext = this;
            InitializeComponent();

        }

        private List<Person> _personenList;

        public List<Person> PersonenList
        {
            get { return _personenList; }
            set { _personenList = value; OnPropertyChanged(); }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        private void Bank_Account(object sender, RoutedEventArgs e)
        {
            this.XamGridExtensionInstance.AddFiltersettings();
        }

        private void Reset(object sender, RoutedEventArgs e)
        {
            XamGridExtensionInstance.ResetFiltersettings();
            InitTestData();
        }

        private void InitTestData()
        {
            var _newList = new List<Person>();
            for (var i = 0; i < 1000; i++)
            {
                _newList.Add(new Person(i));
            }
            PersonenList = _newList;
        }

        private void ContainsA(object sender, RoutedEventArgs e)
        {
            XamGridExtensionInstance.AddFiltersettingsName();
        }
    }


    public class Person : INotifyPropertyChanged
    {
        public Person()
        {
            
        }

        public Person(int number)
        {
            _age = number % 50;
            _name = "Name " + number;
            _bankAccount = number * 100;
        }

        private int _age;

        public int Age
        {
            get { return _age; }
            set { _age = value; OnPropertyChanged(); }
        }


        private string _name;

        public string Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged(); }
        }

        private int _bankAccount;

        public int BankAccount
        {
            get { return _bankAccount; }
            set { _bankAccount = value; OnPropertyChanged(); }
        }







        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
