﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Infragistics;
using Infragistics.Controls.Grids;

namespace GridTestProject
{
    public class XamGridExtension : XamGrid
    {
        public XamGridExtension()
        {
            FilteringSettings.AllowFiltering = FilterUIType.FilterMenu;
        }

        public void AddFiltersettings()
        {
            var rowFilter = this.RowsManager.RowFiltersCollectionResolved["BankAccount"];
            if (rowFilter == null)
            {
                rowFilter = new RowsFilter(typeof(int), (Column)Columns["BankAccount"]);
            }
            else
            {
                rowFilter.Conditions.Clear();
            }

            rowFilter.Conditions.Add(new ComparisonCondition
            {
                Operator = ComparisonOperator.GreaterThan,
                FilterValue = 400
            });

            RowsManager.RowFiltersCollection.Clear();
            RowsManager.RowFiltersCollection.Add(rowFilter);
        }


        public void AddFiltersettingsName()
        {
            RowsManager.RowFiltersCollection.Clear();
            var rowFilter = this.RowsManager.RowFiltersCollectionResolved["Name"];
            if (rowFilter == null)
            {
                rowFilter = new RowsFilter(typeof(string), (Column)Columns["Name"]);
            }
            else
            {
                rowFilter.Conditions.Clear();
            }

            rowFilter.Conditions.Add(new ComparisonCondition
            {
                Operator = ComparisonOperator.Contains,
                FilterValue = "2"
            });
            RowsManager.RowFiltersCollection.Add(rowFilter);
        }

        public void ResetFiltersettings()
        {
            RowsManager.RowFiltersCollection.Clear();
        }

    }
}
